APP = rcsj_cpu_fp32

CXX=g++
#CXX=clang++

SRC_DIR=./

CXXFLAGS=-c -Wall -std=c++2a -O3

CXXFLAGS+=-DFP32
CXXFLAGS+=-I/include
LDFLAGS=

## gprof flags
#CXXFLAGS+=-pg
#LDFLAGS=+=-pg

CXXFLAGS+=-fopenmp
LDFLAGS+=-fopenmp

CXXFLAGS+=-DFP32
CXXFLAGS+=-DTIME_CHECK

END_FLAGS=-lm -ldl

# Optimization flags
CXXFLAGS+=-march=native
CXXFLAGS+=-mavx
CXXFLAGS+=-funroll-all-loops 
CXXFLAGS+=-unroll-loops 
CXXFLAGS+=-omit-frame-pointer 
CXXFLAGS+=-fno-stack-protector
CXXFLAGS+=-ffast-math

SRCS=$(wildcard ${SRC_DIR}*.cpp)
APP_OBJS = $(SRCS:.cpp=.o)

all: $(SRCS) $(APP)

$(APP): $(APP_OBJS)
	$(CXX) $(LDFLAGS) $(APP_OBJS) -o $@ $(USRINC) $(END_FLAGS)

$(SRCS).o:
	$(CXX) $(CXXFLAGS) $< -o $@ 

clean:
	rm -rf ${SRC_DIR}*.o $(APP) ${SRC_DIR}*.elf ${SRC_DIR}*.gdb
